﻿/// <reference path="../../../Resources/TypeDefinitions/jquery/jquery.d.ts"/>
/// <reference path="../../../Resources/TypeDefinitions/knockout/knockout.d.ts"/>
/// <reference path="../../../rubbish.ts"/>

var ChangeAvailabilityPageViewModel = (function () {
    function ChangeAvailabilityPageViewModel(input) {
        this.highAvailability = input.highAvailability;
        this.enabled = input.enabled;
        this.integratedWebServer = input.integratedWebServer;
        this.hasLicense = input.hasLicense;
        this.changeModeUrl = input.changeModeUrl;
        this.pingServerUrl = input.pingServerUrl;

        this.licenseName = input.highAvailability ? "ProGet High Availability" : "ProGet Enterprise with Load Balancing";
        this.modeName = input.highAvailability ? "High Availability Mode" : "Load Balancing";
        this.inedoComUrl = input.highAvailability ? "http://inedo.com/proget/high-availability" : "http://inedo.com/proget/load-balancing";

        this.isUpdating = ko.observable(false);
        this.canEdit = ko.observable(!input.integratedWebServer && input.hasLicense);
    }
    ChangeAvailabilityPageViewModel.prototype.changeModeClick = function () {
        var _this = this;
        this.isUpdating(true);
        this.canEdit(false);
        $.ajax({
            url: this.changeModeUrl,
            data: { highAvailability: this.highAvailability, enabled: !this.enabled },
            type: 'POST'
        });

        var pingHandler = function () {
            $.ajax({
                url: _this.pingServerUrl,
                type: 'POST',
                success: function () {
                    parent.location.reload(true);
                },
                complete: function () {
                    setTimeout(pingHandler, 5000);
                }
            });
        };

        setTimeout(pingHandler, 5000);
    };
    return ChangeAvailabilityPageViewModel;
})();
